
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ParticipantsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const participants = await db.participants.create(
            {
                id: data.id || undefined,
        
        display_name: data.display_name
        ||
        null
            ,
            
        participant_role: data.participant_role
        ||
        null
            ,
            
        join_status: data.join_status
        ||
        null
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
        left_at: data.left_at
        ||
        null
            ,
            
        is_muted: data.is_muted
        ||
        false
        
            ,
            
        is_video_enabled: data.is_video_enabled
        ||
        false
        
            ,
            
        is_screen_sharing: data.is_screen_sharing
        ||
        false
        
            ,
            
        network_score: data.network_score
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await participants.setConference( data.conference || null, {
            transaction,
        });
        
        await participants.setUser( data.user || null, {
            transaction,
        });
        
        await participants.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return participants;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const participantsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                display_name: item.display_name
            ||
            null
            ,
            
                participant_role: item.participant_role
            ||
            null
            ,
            
                join_status: item.join_status
            ||
            null
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
                left_at: item.left_at
            ||
            null
            ,
            
                is_muted: item.is_muted
            ||
            false
        
            ,
            
                is_video_enabled: item.is_video_enabled
            ||
            false
        
            ,
            
                is_screen_sharing: item.is_screen_sharing
            ||
            false
        
            ,
            
                network_score: item.network_score
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const participants = await db.participants.bulkCreate(participantsData, { transaction });

        // For each item created, replace relation files
        

        return participants;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const participants = await db.participants.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.display_name !== undefined) updatePayload.display_name = data.display_name;
        
        
        if (data.participant_role !== undefined) updatePayload.participant_role = data.participant_role;
        
        
        if (data.join_status !== undefined) updatePayload.join_status = data.join_status;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        if (data.left_at !== undefined) updatePayload.left_at = data.left_at;
        
        
        if (data.is_muted !== undefined) updatePayload.is_muted = data.is_muted;
        
        
        if (data.is_video_enabled !== undefined) updatePayload.is_video_enabled = data.is_video_enabled;
        
        
        if (data.is_screen_sharing !== undefined) updatePayload.is_screen_sharing = data.is_screen_sharing;
        
        
        if (data.network_score !== undefined) updatePayload.network_score = data.network_score;
        
        
        updatePayload.updatedById = currentUser.id;

        await participants.update(updatePayload, {transaction});

        
        
        if (data.conference !== undefined) {
            await participants.setConference(
              
              data.conference,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await participants.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await participants.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return participants;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const participants = await db.participants.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of participants) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of participants) {
                await record.destroy({transaction});
            }
        });


        return participants;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const participants = await db.participants.findByPk(id, options);

        await participants.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await participants.destroy({
            transaction
        });

        return participants;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const participants = await db.participants.findOne(
            { where },
            { transaction },
        );

        if (!participants) {
            return participants;
        }

        const output = participants.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quality_reports_participant = await participants.getQuality_reports_participant({
            transaction
        });
        
        
        
        
        
        output.conference = await participants.getConference({
            transaction
        });
        
        
        output.user = await participants.getUser({
            transaction
        });
        
        
        output.organizations = await participants.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.conferences,
        as: 'conference',
        
        where: filter.conference ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conference.split('|').map(term => Utils.uuid(term)) } },
            {
              conference_key: {
                [Op.or]: filter.conference.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.display_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'participants',
                        'display_name',
                        filter.display_name,
                    ),
                };
            }
            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.left_atRange) {
                const [start, end] = filter.left_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.network_scoreRange) {
                const [start, end] = filter.network_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    network_score: {
                    ...where.network_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    network_score: {
                    ...where.network_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.participant_role) {
                where = {
                    ...where,
                participant_role: filter.participant_role,
            };
            }
            
            if (filter.join_status) {
                where = {
                    ...where,
                join_status: filter.join_status,
            };
            }
            
            if (filter.is_muted) {
                where = {
                    ...where,
                is_muted: filter.is_muted,
            };
            }
            
            if (filter.is_video_enabled) {
                where = {
                    ...where,
                is_video_enabled: filter.is_video_enabled,
            };
            }
            
            if (filter.is_screen_sharing) {
                where = {
                    ...where,
                is_screen_sharing: filter.is_screen_sharing,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.participants.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'participants',
                        'display_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.participants.findAll({
            attributes: [ 'id', 'display_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['display_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.display_name,
        }));
    }

    
};

